#include <linux/kobject.h>
#include <linux/string.h>
#include <linux/sysfs.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/blkdev.h>
#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/init.h>
#include <asm/i387.h>
#include <linux/delay.h>
#include <linux/sched.h>
#include <linux/kernel.h> /* printk() */
#include <linux/slab.h> /* kmalloc() */
#include <linux/fs.h> /* everything... */
#include <linux/errno.h> /* error codes */
#include <linux/timer.h>
#include <linux/types.h> /* size_t */
#include <linux/fcntl.h> /* O_ACCMODE */
#include <linux/hdreg.h> /* HDIO_GETGEO */
#include <linux/kdev_t.h>
#include <linux/vmalloc.h>
#include <linux/genhd.h>
#include <linux/blkdev.h>
#include <linux/bio.h>
#include <linux/sort.h>
#include <linux/dm-kcopyd.h>
#include <asm/div64.h>
#define TIERING_PAGE_SIZE 4096
#define TIERING_SEC_SIZE 4096
#define TIERING_DEV_NAME "tieringdev"
static struct kobject *example_kobj;

struct tablerow {
	sector_t sec;
	unsigned char blkNumber;
	char valid;

};
struct tieringSort {
	unsigned int rowNumber;
	unsigned int priority;
};
struct accessTableRow {
	unsigned int access;
	unsigned int pageCount;
	unsigned int readCount;
};
struct TieringStatistics {

	unsigned long long readCount;
	unsigned long long writeCount;
	unsigned long long readPageCount;
	unsigned long long writePageCount;
};
struct migration_info {
	struct tablerow* Block1, *Block2;
	struct dm_io_region *src, *dest;
	struct completion *Compete;
	struct page *Page1;
};
struct tiering_private {
	int major;
	long long size;
	struct request_queue *queue;
	struct gendisk *gd;
	struct block_device *raidDevices[10];
	int extentCapacity[10];
	char deviceName[10][50];
	struct TieringStatistics *statistics;
	int numberOfDevices;
	int ** bitmap;
	sector_t Devs_Size[10];
	struct tablerow *table;
	struct accessTableRow * accessTable;
	struct semaphore sem;
	struct semaphore sem2;
	sector_t totalSecSize;
	sector_t chunkCount;
	struct tieringSort* tieringsort;
};
struct Mig_Q {
	struct tablerow *T_Row;
	struct Mig_Q *Next;
};
struct multipleBio {
	struct bio** bios;
	int bioCount;
	void* Private;
	struct bio* masterBio;
	atomic_t completed;

};
static struct dm_kcopyd_client *kcopyd_client;
int metadataOnly = 0;
int number_of_bios = 0;
static void * vpage1, *vpage2;
static struct tiering_private *tiering;
static int lastOccupiedTier = 0;
static sector_t lastOccupiedExtent = 0;
static char resetimport = 1;
int tieringdummy = 0;
int first_call_alloc = 0;

unsigned int metadataNumber = 0, dataNumber = 0, metadataSize = 0, dataSize = 0,
		metadataAllocated = 0, dataAllocated = 0, dataMiss = 0,
		metadataMiss = 0;
static struct Mig_Q *migrationBuffer;
static unsigned int lastOccupiedMigBuffer = -1;

int tieringcmpint(const void *a, const void *b) {
	if ((*(struct tieringSort*) b).priority
			> (*(struct tieringSort*) a).priority)
		return 1;
	else if (tiering->table[(*(struct tieringSort*) b).rowNumber].valid == 1
			&& tiering->table[(*(struct tieringSort*) a).rowNumber].valid == 0)
		return 1;
	else
		return -1;

}
static ssize_t showDevices(struct kobject *kobj, struct kobj_attribute *attr,
		char *buf) {

	return sprintf(buf, "%d\n", tiering->numberOfDevices);
}

ssize_t DisableMetaData(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {

	metadataOnly = 0;
	return count;
}

void size_of_info(unsigned int Table_size) {
	long long Total = 0; 
	Total += 1 * tiering->numberOfDevices * 50; 
	Total += 4; 
	Total += sizeof(size_t); 
	Total += 8;
	Total += Table_size * sizeof(struct tablerow);
	tiering->size = Total;
}

static void Writing_Info_Bio_End(struct bio *bi, int err) {
    void * a;

    a = kmap(bi->bi_io_vec[0].bv_page);
    printk(KERN_INFO"%llu , %d, %p \n", bi->bi_sector, err, (int*) (a));
    kunmap(a);
}

int save_tiering_info(void) {
	void* Pointer, **listP;
	struct bio* BO;
	int j, Ps = 4096, Pnum = 0, ObjS, NumPG;
	unsigned int i, n;
	struct page **P;

	n = tiering->size / 4096;
	if (tiering->size % 4096)
		n++;
	P = kmalloc(n * sizeof(struct page *), GFP_KERNEL);
	listP = kmalloc(n * sizeof(void*), GFP_KERNEL);
	for (i = 0; i < n; i++)
		P[i] = alloc_page( GFP_KERNEL | GFP_DMA );

	listP[0] = Pointer = kmap(P[0]);
	memcpy(Pointer, &(tiering->size), 8);
	Pointer += 8;
	Ps -= 8;
	memcpy(Pointer, &(tiering->numberOfDevices), 4);
	Pointer += 4;
	Ps -= 4;
	for (i = 0; i < tiering->numberOfDevices; i++) {
		memcpy(Pointer, &(tiering->deviceName[i]), 50);
		Pointer += 50;
		Ps -= 50;
	}
	memcpy(Pointer, &(lastOccupiedExtent), 4);
	Pointer += 4;
	Ps -= 4;
	memcpy(Pointer, &(lastOccupiedTier), 4);
	Pointer += 4;
	Ps -= 4;
	i = 0;
	while (i < tiering->chunkCount) {
		while (Ps >= sizeof(struct tablerow) && i < tiering->chunkCount) { 
			memcpy(Pointer, &(tiering->table[i]), sizeof(struct tablerow));
			Ps -= sizeof(struct tablerow);
			Pointer += sizeof(struct tablerow);
			i++;
		}
		if (i < tiering->chunkCount) {
			ObjS = sizeof(struct tablerow) - Ps;
			memcpy(Pointer, &(tiering->table[i]), Ps);
			++Pnum;
			if (Pnum >= n-1)
				break;
			listP[Pnum] = Pointer = kmap(P[Pnum]);
			tiering->table[i+1];
			memcpy(Pointer, &(tiering->table[i]) + Ps, ObjS);
			Ps = 4096 - ObjS;
			Pointer += ObjS;
			i++;
		}
	} 
	NumPG = n / 128;
	if (n % 128)
		NumPG++;
	for (i = 0; i < NumPG - 1; i++) {
		BO = bio_kmalloc(GFP_KERNEL, 128);
		BO->bi_sector = i * 128 * 8;
		BO->bi_bdev = tiering->raidDevices[0];
		BO->bi_rw = WRITE;
		BO->bi_end_io = Writing_Info_Bio_End;
		for (j = 0; j < 128; j++)
			bio_add_page(BO, P[i * 128 + j], 4096, 0);
		generic_make_request(BO);
	}
	BO = bio_kmalloc(GFP_KERNEL, n - ((NumPG - 1) * 128));
	BO->bi_bdev = tiering->raidDevices[0];
	BO->bi_sector = (NumPG - 1) * 128 * 8;
	BO->bi_rw = WRITE;
	BO->bi_end_io = Writing_Info_Bio_End;
	for (j = 0; j < n - ((NumPG - 1) * 128); j++)
		bio_add_page(BO, P[(NumPG - 1) * 128 + j], 4096, 0);
	generic_make_request(BO);
	return 0;
}
static void Complete_Loading(void* Page) {
	void* Pointer, **listP;
	int Ps = 4096, Pnum = 0, ObjS; 
	unsigned int i, n;
	struct page **P;
	n = tiering->size / 4096;
	if (tiering->size % 4096)
		n++;
	P = Page;
	listP = kmalloc(n * sizeof(void*), GFP_KERNEL);
	listP[0] = Pointer = kmap(P[0]);
	memcpy(&(tiering->size), Pointer, 8);
	Pointer += 8;
	Ps -= 8;
	memcpy( &(tiering->numberOfDevices), Pointer, 4);
	Pointer += 4;
	Ps -= 4;
	for (i = 0; i < tiering->numberOfDevices; i++) {
		memcpy(&(tiering->deviceName[i]), Pointer, 50);
		Pointer += 50;
		Ps -= 50;
	}
	memcpy( &(lastOccupiedExtent), Pointer, 4);
	Pointer += 4;
	Ps -= 4;
	memcpy( &(lastOccupiedTier), Pointer, 4);
	Pointer += 4;
	Ps -= 4;
	i = 0;
	while (i < tiering->chunkCount) {
		while (Ps >= sizeof(struct tablerow) && i < tiering->chunkCount) { 
			memcpy(&(tiering->table[i]), Pointer, sizeof(struct tablerow));
			Ps -= sizeof(struct tablerow);
			Pointer += sizeof(struct tablerow);
			i++;
		}
		if (i < tiering->chunkCount) {
			ObjS = sizeof(struct tablerow) - Ps;
			memcpy(&(tiering->table[i]), Pointer, Ps);
			++Pnum;
			listP[Pnum] = Pointer = kmap(P[Pnum]);
			memcpy(&(tiering->table[i]) + Ps, Pointer, ObjS);
			Ps = 4096 - ObjS;
			Pointer += ObjS;
			i++;
		}
	}
	printk("Tiering : Complete Loading Ended.\n");
	up(&tiering->sem2);
}

static void alloc_tables(void) {
	int i;
	sector_t devSecSize[10];
	size_t tblSize;

	tiering->statistics = kzalloc(
			tiering->numberOfDevices * sizeof(*(tiering->statistics)),
			GFP_KERNEL);
	for (i = 0; i < tiering->numberOfDevices; i++) {
		devSecSize[i] = get_capacity(tiering->raidDevices[i]->bd_disk);
		//devSecSize[i] = (i == 0)? 64 * 1024*2: 10*1024*1024*2;
	}
	tblSize = (512 * tiering->totalSecSize / TIERING_PAGE_SIZE);
	tiering->chunkCount = tblSize;
	tiering->table = vmalloc(tblSize * sizeof(struct tablerow));
	tiering->accessTable = vmalloc(tblSize * sizeof(struct accessTableRow));
	tiering->tieringsort = vmalloc(tblSize * sizeof(struct tieringSort));
	tiering->size += tblSize * sizeof(struct tablerow);
	for (i = 0; i < tblSize; i++) {
		tiering->table[i].valid = 0;
		tiering->accessTable[i].access = 0;
		memset(&tiering->tieringsort[i], 0, sizeof(struct tieringSort));
		tiering->tieringsort[i].rowNumber = i;
	}
}
static void Complete_bio_End(struct bio* bi, int err) {
	if (atomic_dec_and_test(
			&(((struct multipleBio*) bi->bi_private)->completed))) {
		Complete_Loading(((struct multipleBio*) bi->bi_private)->Private);
		
	} else
		printk("number of Sector: %llu\n", bi->bi_sector);
	bio_put(bi);
}

static void Get_Num_of_Pages_Bio_End(struct bio *bi, int err) {

	void *Pointer, **listP;
	struct page **P;
	int i, NumPG, j;
	unsigned int n;
	struct multipleBio *mbio;
	struct bio * bb;

	Pointer = kmap(bi->bi_io_vec[0].bv_page);
	memcpy(&(tiering->size), Pointer, 8);
	printk("%d\n", *((int*) Pointer));
	Pointer += 8;
	memcpy(&(tiering->numberOfDevices), Pointer, 4);
	Pointer += 4;
	for (i = 0; i < tiering->numberOfDevices; i++) {
		memcpy(&(tiering->deviceName[i]), Pointer, 50);
		Pointer += 50;
	}
	kunmap(bi->bi_io_vec[0].bv_page);
	__free_page(bi->bi_io_vec->bv_page);
	n = tiering->size / 4096;
	if (tiering->size % 4096)
		n++;
	P = kmalloc(n * sizeof(struct page *), GFP_KERNEL);
	listP = kmalloc(n * sizeof(void*), GFP_KERNEL);
	for (i = 0; i < n; i++)
		P[i] = alloc_page( GFP_KERNEL | GFP_DMA );

	NumPG = n / 128;
	if (n % 128)
		NumPG++;

	mbio = kmalloc(sizeof(struct multipleBio), GFP_KERNEL);
	mbio->bioCount = NumPG;
	mbio->Private = P;
	atomic_set(&mbio->completed, NumPG);

	for (i = 0; i < NumPG - 1; i++) {
		bb = bio_kmalloc(GFP_KERNEL, 128);
		bb->bi_sector = i * 128 * 8;
		bb->bi_bdev = tiering->raidDevices[0];
		bb->bi_rw = READ;
		bb->bi_end_io = Complete_bio_End;
		bb->bi_private = mbio;
		for (j = 0; j < 128; j++)
			bio_add_page(bb, P[i * 128 + j], 4096, 0);
		generic_make_request(bb);
	}
	bb = bio_kmalloc(GFP_KERNEL, 128);
	bb->bi_bdev = tiering->raidDevices[0];
	bb->bi_sector = (NumPG - 1) * 128 * 8;
	bb->bi_rw = READ;
	bb->bi_private = mbio;
	bb->bi_end_io = Complete_bio_End;
	for (j = 0; j < n - ((NumPG - 1) * 128); j++) {
		bio_add_page(bb, P[(NumPG - 1) * 128 + j], 4096, 0);
	}
	generic_make_request(bb);
}

static void splitedBioEnd(struct bio *bi, int err) {

	if (atomic_dec_and_test(
			&(((struct multipleBio*) bi->bi_private)->completed))) {
		bio_endio(((struct multipleBio*) bi->bi_private)->masterBio, err);
		kfree(((struct multipleBio*) bi->bi_private));
	}
	bio_put(bi);
}
static void mig_bios_second_end(struct bio *bi, int err) {

	sector_t temp;
	unsigned char devNumber;
	devNumber = ((struct migration_info*) (bi->bi_private))->Block1->blkNumber;
	((struct migration_info*) (bi->bi_private))->Block1->valid = 1;
	((struct migration_info*) (bi->bi_private))->Block2->valid = 1;
	temp = ((struct migration_info*) (bi->bi_private))->Block1->sec;
	((struct migration_info*) (bi->bi_private))->Block1->blkNumber =
			((struct migration_info*) (bi->bi_private))->Block2->blkNumber;
	((struct migration_info*) (bi->bi_private))->Block1->sec =
			((struct migration_info*) (bi->bi_private))->Block2->sec;
	((struct migration_info*) (bi->bi_private))->Block2->blkNumber = devNumber;
	((struct migration_info*) (bi->bi_private))->Block2->sec = temp;
	complete((((struct migration_info*) (bi->bi_private))->Compete));
	__free_page(((struct migration_info*) bi->bi_private)->Page1);
	kfree(((struct migration_info*) bi->bi_private)->src);
	kfree(((struct migration_info*) bi->bi_private)->dest);
	kfree(((struct migration_info*) bi->bi_private));

	bio_put(bi);
}

static void copy_callback2(int read_err, unsigned long write_err, void *context) {
	struct bio* bio1;
	struct migration_info *minfo;
	minfo = (struct migration_info *) context;
	bio1 = bio_kmalloc(GFP_KERNEL, 1);
	minfo = (struct migration_info *) context;
	bio1->bi_bdev = tiering->raidDevices[minfo->Block2->blkNumber];
	bio1->bi_sector = minfo->Block2->sec;
	bio_add_page(bio1, minfo->Page1, 4096, 0);
	bio1->bi_rw = 1;
	bio1->bi_private = minfo;
	bio1->bi_end_io = mig_bios_second_end;
	generic_make_request(bio1);
}
static void mig_bios_end(struct bio *bi, int err) {

	struct migration_info *minfo;
	minfo = (struct migration_info *) bi->bi_private;
	bio_put(bi);
	complete(minfo->Compete);	
}

static int migrating_Two_Blocks(struct tablerow* Tr1, struct tablerow* Tr2,
		struct completion *COM, struct migration_info *minfo) {

	struct bio* bio1;

	tieringdummy = 4;

	tieringdummy = 3;
	minfo->Page1 = alloc_page(GFP_KERNEL);
	bio1 = bio_kmalloc(GFP_KERNEL, 1);

	tieringdummy = 2;
	minfo->Block1 = (Tr1);
	minfo->Block2 = (Tr2);
	bio1->bi_bdev = tiering->raidDevices[minfo->Block1->blkNumber];

	bio1->bi_sector = minfo->Block1->sec;

	bio_add_page(bio1, minfo->Page1, 4096, 0);

	minfo->Compete = COM;

	bio1->bi_rw = 0;

	bio1->bi_private = minfo;

	bio1->bi_end_io = mig_bios_end;

	generic_make_request(bio1);

	return 0;

}
static int alloc_extent(sector_t extentNumber) {
	if(first_call_alloc == 0){
		lastOccupiedExtent = 0 ;
		lastOccupiedMigBuffer = 0;
		lastOccupiedTier = 0;
	}
	if (tiering->extentCapacity[lastOccupiedTier] < lastOccupiedExtent + 1) {
		lastOccupiedExtent = 0;
		lastOccupiedTier++;
	}
	tiering->table[extentNumber].blkNumber = lastOccupiedTier;
	tiering->table[extentNumber].sec = lastOccupiedExtent * TIERING_PAGE_SIZE
			/ 512; 
	first_call_alloc = 1;
	tiering->table[extentNumber].valid = 1;
	lastOccupiedExtent++;
	return 0;
}
static int tiering_make_request(struct request_queue *q, struct bio *bio) {
	
	unsigned int Num_of_Pages, Page_Offset, Bytes_needed, Remaining_Page_Size;
	unsigned int chunckNumber = -1;
	unsigned int temp;
	struct multipleBio *mbio;
	int i = 0, j = 0, k = 0, z = 0;
	sector_t tmp;
	dataNumber++;
	down(&tiering->sem);
	if ( bio->bi_vcnt < 1) {


		if (tiering->table[(bio->bi_sector) / ((int)TIERING_PAGE_SIZE / 512)].valid
				== 0) {
			alloc_extent((bio->bi_sector) / (TIERING_PAGE_SIZE / 512));

		}

		bio->bi_bdev = tiering->raidDevices[tiering->table[(bio->bi_sector)
				/ (TIERING_PAGE_SIZE / 512)].blkNumber];
		bio->bi_sector = tiering->table[(bio->bi_sector)
				/ (TIERING_PAGE_SIZE / 512)].sec;

			up(&tiering->sem);
		return 1;
	}

	mbio = kmalloc(sizeof(struct multipleBio), GFP_KERNEL);
		mbio->masterBio = bio;
	Num_of_Pages = 1;
	Page_Offset = (bio->bi_sector * 512) % TIERING_PAGE_SIZE;

	if (bio->bi_size > (TIERING_PAGE_SIZE - Page_Offset)) {
		temp = bio->bi_size - (TIERING_PAGE_SIZE - Page_Offset);
		while (temp > TIERING_PAGE_SIZE) {
			Num_of_Pages++;
			temp -= TIERING_PAGE_SIZE;
		}
		Remaining_Page_Size = temp;
		if (Remaining_Page_Size != 0)
			Num_of_Pages++;
		else
			Remaining_Page_Size = TIERING_PAGE_SIZE;
	} else {
		Num_of_Pages = 1;
		Remaining_Page_Size = bio->bi_size;
	}
	mbio->bios = kmalloc(Num_of_Pages * sizeof(struct bio*), GFP_KERNEL);
	mbio->bioCount = Num_of_Pages;
	atomic_set(&mbio->completed, Num_of_Pages);

	temp = 0;
	for (i = 0; i < Num_of_Pages; i++) {
		Bytes_needed = TIERING_PAGE_SIZE;
		if (i == 0 && Num_of_Pages > 1)
			Bytes_needed = TIERING_PAGE_SIZE - Page_Offset;
		if (i == 0 && Num_of_Pages == 1)
			Bytes_needed = bio->bi_size;
		if (i == (Num_of_Pages - 1) && Num_of_Pages > 1)
			Bytes_needed = Remaining_Page_Size;
		temp += Bytes_needed;
		chunckNumber = (bio->bi_sector + (temp - Bytes_needed) / 512)
				/ (TIERING_PAGE_SIZE / 512);
		mbio->bios[i] = bio_kmalloc(GFP_KERNEL,
				Bytes_needed / 4096); 
		memcpy(mbio->bios[i]->bi_io_vec,
				&bio->bi_io_vec[(temp-Bytes_needed)/4096],
				(Bytes_needed/4096) * sizeof(struct bio_vec));
		mbio->bios[i]->bi_flags |= 1 << BIO_CLONED;
		mbio->bios[i]->bi_rw = bio->bi_rw;
		mbio->bios[i]->bi_private = mbio;
		k = 0;
		z = 0;
		tmp = (bio->bi_sector + (temp - Bytes_needed) / 512)
				/ (TIERING_PAGE_SIZE / 512);
		if (tiering->table[tmp].valid == 0) {
			alloc_extent(tmp);
		}
		mbio->bios[i]->bi_bdev =
				tiering->raidDevices[tiering->table[tmp].blkNumber];
		mbio->bios[i]->bi_size = Bytes_needed;
		mbio->bios[i]->bi_idx = 0;
		mbio->bios[i]->bi_vcnt = Bytes_needed / 4096;
		if(i == 0)
			mbio->bios[i]->bi_sector = tiering->table[tmp].sec + bio->bi_sector % (TIERING_PAGE_SIZE / 512);
		else mbio->bios[i]->bi_sector = tiering->table[tmp].sec;

		mbio->bios[i]->bi_end_io = splitedBioEnd;

		generic_make_request(mbio->bios[i]);
	}
	up(&tiering->sem);
	return 0;
}

int pt_getgeo(struct block_device * block_device, struct hd_geometry * hg) {
	hg->heads = 255;
	hg->sectors = 63;
	hg->cylinders = get_capacity(block_device->bd_disk);
	sector_div(hg->cylinders, hg->heads * hg->sectors);
	return 0;
}

static struct block_device_operations pt_ops = { .owner = THIS_MODULE, .getgeo =
		pt_getgeo };
static int load_tiering_info(void) {

	struct bio * bb;
	struct page * pp;

	bb = bio_kmalloc(GFP_NOIO, 1);
	pp = alloc_page(GFP_KERNEL | GFP_DMA);
	bb->bi_bdev = tiering->raidDevices[0];
	bb->bi_sector = 0;
	bb->bi_rw = 0;
	bb->bi_end_io = Get_Num_of_Pages_Bio_End;
	bio_add_page(bb, pp, 4096, 0);
	generic_make_request(bb); 
	return 0;
}

static ssize_t startinit(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {
	char type[10];
	struct request_queue *q;
	unsigned int i = 0;
	sector_t tieringsize;
	alloc_tables();
	tiering->major = register_blkdev(0, TIERING_DEV_NAME);
	tiering->queue = blk_alloc_queue(GFP_KERNEL);
	if (tiering->queue == NULL)
		return -1;

	blk_queue_make_request(tiering->queue, tiering_make_request);
	blk_queue_flush(tiering->queue, REQ_FLUSH | REQ_FUA);

	tiering->gd = alloc_disk(1);
	if (!tiering->gd) {

		return -1;
	}

	tiering->gd->major = tiering->major;
	tiering->gd->first_minor = 0;
	tiering->gd->fops = &pt_ops;
	tiering->gd->queue = tiering->queue;
	tiering->gd->private_data = tiering;
	tiering->gd->flags |= GENHD_FL_EXT_DEVT;
	q = bdev_get_queue(tiering->raidDevices[0]);
	if (!q) {
		return -1;
	}

	tiering->gd->queue->limits.max_hw_sectors = q->limits.max_hw_sectors;
	tiering->gd->queue->limits.max_sectors = q->limits.max_sectors;
	tiering->gd->queue->limits.max_segment_size = q->limits.max_segment_size;
	tiering->gd->queue->limits.max_segments = q->limits.max_segments;
	tiering->gd->queue->limits.logical_block_size = TIERING_SEC_SIZE;
	tiering->gd->queue->limits.physical_block_size = TIERING_SEC_SIZE;
	set_bit(QUEUE_FLAG_NONROT, &tiering->gd->queue->queue_flags);

	snprintf(tiering->gd->disk_name, 32, TIERING_DEV_NAME);

	tiering->size += 1 * tiering->numberOfDevices * 50; 
	tiering->size += 4; 
	tiering->size += sizeof(tiering->size);
	if (tiering->size % TIERING_PAGE_SIZE) {

		tieringsize = (tiering->size / TIERING_PAGE_SIZE + 1)
				* TIERING_PAGE_SIZE;
	}
	i = 0;

	set_capacity(tiering->gd,
			tiering->totalSecSize - (i + 1) * TIERING_PAGE_SIZE);
	sscanf(buf, "%s", type);
	down(&tiering->sem2);
	if (type[0] == '1') {

		load_tiering_info();
		down(&tiering->sem2);
	}
	add_disk(tiering->gd);
	return count;
}

static ssize_t import(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {

	unsigned int chunk = 0, priority = 0;
	if (resetimport == 1) {
		lastOccupiedTier = 0;
		lastOccupiedExtent = 0;
	}
	resetimport = 0;
	sscanf(buf, "%d %d", &chunk, &priority);
	if (priority == 0)
		return count;
	alloc_extent(chunk);
	tiering->tieringsort[chunk].priority = priority;
	return count;
}
static ssize_t Getnumbers(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {
	char two_numbers[30];
	int i,j,z= 1;
	sscanf(buf, "%s", two_numbers);
	unsigned int temp, first_num = 0 , second_num = 0;
	for(i = 0 ; two_numbers[i] != ',' ; i++);
	for(j = i-1 ; j >= 0 ; j--){
		temp = (two_numbers[j] - '0') * z;
		z*=10;
		first_num += temp;
	}
	z = 1;
	for(j = i+1 ; two_numbers[j] != 0 ; j++);
	for( j = j -1 ; j > i ; j--){
		temp = (two_numbers[j] - '0') * z;
		z*=10;
		second_num += temp;
	}

	alloc_extent(first_num);
	tiering->tieringsort[first_num].priority = second_num;

	return count;
}
static ssize_t AddDevices(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {
	char Device_path[30];
	sector_t deviceCapacity;
	sscanf(buf, "%s", Device_path);
	tiering->raidDevices[tiering->numberOfDevices] = blkdev_get_by_path(
			Device_path, FMODE_READ | FMODE_WRITE | FMODE_EXCL, tiering);
	if (!tiering->raidDevices[tiering->numberOfDevices]) {
		return -1;
	}
	deviceCapacity = get_capacity(
			tiering->raidDevices[tiering->numberOfDevices]->bd_disk);
	//deviceCapacity = (tiering->numberOfDevices == 0)? 64* 1024*2:10*1024*1024*2;
	tiering->totalSecSize += deviceCapacity;
	tiering->extentCapacity[tiering->numberOfDevices] = deviceCapacity
			* 512/ TIERING_PAGE_SIZE;
	tiering->numberOfDevices++;

	return count;
}
static void printPage2(struct bio *bi, int err) {
	vpage2 = kmap(bi->bi_io_vec->bv_page);
	printk("%s : %ld", bi->bi_bdev->bd_disk->disk_name, *((long *) (vpage2)));
	printk("%s : %ld", bi->bi_bdev->bd_disk->disk_name,
			*((long *) (vpage2) + 1024));
	printk("%s : %ld", bi->bi_bdev->bd_disk->disk_name,
			*((long *) (vpage2) + 2048));

}
static void printPage(struct bio *bi, int err) {
	struct bio* bb;
	struct page * pp;
	vpage1 = kmap(bi->bi_io_vec->bv_page);
	printk("%s : %ld", bi->bi_bdev->bd_disk->disk_name, *((long *) (vpage1)));
	printk("%s : %ld", bi->bi_bdev->bd_disk->disk_name,
			*((long *) (vpage1) + 1024));
	printk("%s : %ld", bi->bi_bdev->bd_disk->disk_name,
			*((long *) (vpage1) + 2048));
	bb = bio_kmalloc(GFP_NOIO, 1);
	pp = alloc_page(GFP_KERNEL | GFP_DMA);
	bb->bi_bdev = tiering->raidDevices[0];
	bb->bi_sector = 0;
	bb->bi_rw = 0;
	bb->bi_end_io = printPage2;
	bio_add_page(bb, pp, 4096, 0);
	generic_make_request(bb);
	kunmap(bi->bi_io_vec->bv_page);
}

static ssize_t zeroStatistics(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {
	unsigned int i;

	for (i = 0; i < tiering->chunkCount; i++){
		tiering->tieringsort[i].rowNumber = i;
	tiering->tieringsort[i].priority = 0;}
	resetimport = 1;

	return count;
}
static ssize_t tieringSave(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {
	save_tiering_info();
	return count;
}
static void copy_callback(int read_err, unsigned long write_err, void *context) {
	complete(context);
}
static void calculatePiority(void) {

	unsigned int i;

	for (i = 0; i < tiering->chunkCount; i++) {
		tiering->tieringsort[i].priority = tiering->accessTable[i].access
				+ ((unsigned long long) tiering->accessTable[i].access ^ 2)
						/ tiering->accessTable[i].pageCount
				+ tiering->accessTable[i].readCount / 10;
	}
}
static ssize_t StartMigration(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {
	struct Mig_Q*** Mig_Table;
	struct Mig_Q *temp, *temp1, *temp2;
	struct migration_info *minfo;
	struct dm_io_region *src, *dest;
	int i, j, ii, ti, tj, *zz;
	char HasLoop = 0;
	sector_t tempsec;
	unsigned char devNumber;
	sector_t pointer = 0, tsec = 0;
	unsigned long devSize = 0;
	struct completion Complete_Migration;
	unsigned long long totalMigrations = 0;

	sort(tiering->tieringsort, tiering->chunkCount, sizeof(struct tieringSort),
			tieringcmpint, NULL);
	init_completion(&Complete_Migration);
	Mig_Table = kzalloc(tiering->numberOfDevices * sizeof(struct Mig_Q**),
			GFP_KERNEL);
	zz = kzalloc(tiering->numberOfDevices * sizeof(int), GFP_KERNEL);
	for (i = 0; i < tiering->numberOfDevices; i++)
		Mig_Table[i] = kzalloc(tiering->numberOfDevices * sizeof(struct Mig_Q*),
				GFP_KERNEL);
	for (i = 0; i < tiering->numberOfDevices; i++)
		for (j = 0; j < tiering->numberOfDevices; j++)
			Mig_Table[i][j] = NULL;
	for (i = 0; i < tiering->numberOfDevices; i++) {
		devSize += (get_capacity(tiering->raidDevices[i]->bd_disk) * 512)
				/ TIERING_PAGE_SIZE;
		while (pointer < devSize
				&& tiering->table[tiering->tieringsort[pointer].rowNumber].valid
						== 1) {
			if (tiering->table[tiering->tieringsort[pointer].rowNumber].blkNumber
					!= i) {
				totalMigrations++;
				zz[i]++;
			} //if
			pointer++;
		} //while
	} //for
	migrationBuffer = vmalloc(totalMigrations * sizeof(struct Mig_Q));
	devSize = 0;
	pointer = 0;
	for (i = 0; i < tiering->numberOfDevices; i++) {
		devSize += (get_capacity(tiering->raidDevices[i]->bd_disk) * 512)
				/ TIERING_PAGE_SIZE;
		while (pointer < devSize
				&& tiering->table[tiering->tieringsort[pointer].rowNumber].valid
						== 1) {
			if (tiering->table[tiering->tieringsort[pointer].rowNumber].blkNumber
					!= i) {
				lastOccupiedMigBuffer++;
				temp = &migrationBuffer[lastOccupiedMigBuffer];
				temp->T_Row =
						&(tiering->table[tiering->tieringsort[pointer].rowNumber]);
				temp->Next =
						Mig_Table[i][tiering->table[tiering->tieringsort[pointer].rowNumber].blkNumber];

				Mig_Table[i][tiering->table[tiering->tieringsort[pointer].rowNumber].blkNumber] =
						temp;
			} //if
			pointer++;
		} //while
	} //for
	printk(KERN_ALERT "%d->>%d\n", zz[0], zz[1]);

	for (i = 0; i < tiering->numberOfDevices - 1; i++) {
		for (j = i + 1; j < tiering->numberOfDevices; j++) {
			while (Mig_Table[i][j] != NULL && Mig_Table[j][i] != NULL) {
				zz[0]--;
				if (zz[0] % 1000 == 0)
					printk("%d\n", zz[0]);



	devNumber = Mig_Table[i][j]->T_Row->blkNumber;
	Mig_Table[i][j]->T_Row->valid = 1;
	Mig_Table[j][i]->T_Row->valid = 1;
	tempsec = Mig_Table[i][j]->T_Row->sec;
	Mig_Table[i][j]->T_Row->blkNumber =
			Mig_Table[j][i]->T_Row->blkNumber;
	Mig_Table[i][j]->T_Row->sec =
			Mig_Table[j][i]->T_Row->sec;
	Mig_Table[j][i]->T_Row->blkNumber = devNumber;
	Mig_Table[j][i]->T_Row->sec = tempsec;
				temp1 = Mig_Table[i][j];
				temp2 = Mig_Table[j][i];
				Mig_Table[i][j] = Mig_Table[i][j]->Next;
				Mig_Table[j][i] = Mig_Table[j][i]->Next;
			} //while
		} //for
	} //for
	printk("All Done!\n");
	for (i = 0; i < tiering->numberOfDevices - 1; i++)
		for (j = i; j < tiering->numberOfDevices; j++)
			if (Mig_Table[i][j] != NULL) {
				HasLoop = 1;
				break;
			}

	if (HasLoop) {
		printk("HAS LOOP!!!\n");
		temp = Mig_Table[i][j];
		ti = i;
		tj = j;
		src = kmalloc(sizeof(*src), GFP_ATOMIC);
		dest = kmalloc(sizeof(*dest), GFP_ATOMIC);
		while (Mig_Table[i][j] != NULL)
			for (ii = 0; ii < tiering->numberOfDevices; ii++) {
				if (Mig_Table[ii][i] != NULL) {
					src->bdev = tiering->raidDevices[ii];
					src->count = 8;
					src->sector = Mig_Table[ii][i]->T_Row->sec;
					tsec = Mig_Table[ii][i]->T_Row->sec;
					dest->bdev = tiering->raidDevices[i];
					dest->count = 8;
					dest->sector = Mig_Table[i][j]->T_Row->sec;
					init_completion(&Complete_Migration);
					dm_kcopyd_copy(kcopyd_client, src, 1, dest, 0,
							copy_callback, &Complete_Migration);
					wait_for_completion(&Complete_Migration);
					temp1 = Mig_Table[i][j];
					Mig_Table[i][j] = Mig_Table[i][j]->Next;
					kfree(temp1);
					j = i;
					i = ii;
				} //if
			} //for

		src->bdev = tiering->raidDevices[ti];
		src->count = 8;
		src->sector = temp->T_Row->sec;
		dest->bdev = tiering->raidDevices[tj];
		dest->count = 8;
		dest->sector = tsec;
		init_completion(&Complete_Migration);
		dm_kcopyd_copy(kcopyd_client, src, 1, dest, 0, copy_callback,
				&Complete_Migration);
		wait_for_completion(&Complete_Migration);
		kfree(Mig_Table);
	} //if-->(hasloop)
	vfree(migrationBuffer);

	return count;
}
static ssize_t ShowBlocks(struct kobject *kobj, struct kobj_attribute *attr,
		const char *buf, size_t count) {
	struct bio* bio1;
	struct page *Page1;

	Page1 = alloc_page(GFP_KERNEL | GFP_DMA);
	vpage1 = kmap(Page1);
	memset(vpage1, 1, 1024);
	memset(vpage1+1024, 2, 1024);
	memset(vpage1+2048, 3, 1024);
	memset(vpage1+1024+2048, 4, 1024);
	kunmap(Page1);
	bio1 = bio_kmalloc(GFP_NOIO, 1);
	bio1->bi_bdev = tiering->raidDevices[0];
	bio1->bi_sector = 0;
	bio1->bi_rw = WRITE;
	bio1->bi_end_io = printPage;
	bio_add_page(bio1, Page1, 4096, 0);

	generic_make_request(bio1);
	return count;
}

static struct kobj_attribute GetNums_attribute =
		__ATTR(getnum, 0666, showDevices, Getnumbers);
static struct kobj_attribute show_attribute =
		__ATTR(show, 0666, showDevices, ShowBlocks);
static struct kobj_attribute report_attribute =
		__ATTR(report, 0666, showDevices, ShowBlocks);
static struct kobj_attribute statistics_attribute =
		__ATTR(statistics, 0666, showDevices, zeroStatistics);
static struct kobj_attribute metadata_attribute =
		__ATTR(metadata, 0666 , showDevices, DisableMetaData);
static struct kobj_attribute init_attribute =
		__ATTR(init, 0666 , showDevices, startinit);
static struct kobj_attribute mig_attribute =
		__ATTR(mig, 0666 , showDevices, StartMigration);
static struct kobj_attribute devs_attribute =
		__ATTR(devs, 0666, showDevices, AddDevices);
static struct kobj_attribute save_attribute =
		__ATTR(save, 0666, showDevices, tieringSave);
static struct kobj_attribute import_attribute =
		__ATTR(import, 0666, showDevices, import);

static struct attribute *attrs[] = { &metadata_attribute.attr,
		&init_attribute.attr, &devs_attribute.attr, &show_attribute.attr,
		&statistics_attribute.attr, &save_attribute.attr,
		&report_attribute.attr, &mig_attribute.attr, &import_attribute.attr,
		&GetNums_attribute.attr,
		NULL, /* need to NULL terminate the list of attribute */ ////
		};
static struct attribute_group attr_group = { .attrs = attrs, };

int hello_init(void) {

	int retval = 0;
	static struct proc_dir_entry *entry;

	example_kobj = kobject_create_and_add("tiering", fs_kobj);
	retval = sysfs_create_group(example_kobj, &attr_group);


	tiering = kzalloc(sizeof(struct tiering_private), GFP_KERNEL);
	sema_init(&tiering->sem, 1);
	sema_init(&tiering->sem2, 1);
	tiering->totalSecSize = 0;
	entry = NULL;
	return retval;
}

void hello_exit(void) {
	kobject_put(example_kobj);
	if (tiering->gd) {
		del_gendisk(tiering->gd);
		put_disk(tiering->gd);
	}
	if (tiering->queue)
		blk_cleanup_queue(tiering->queue);

	blkdev_put(tiering->raidDevices[1], FMODE_READ | FMODE_WRITE | FMODE_EXCL);
	blkdev_put(tiering->raidDevices[0], FMODE_READ | FMODE_WRITE | FMODE_EXCL);
	unregister_blkdev(tiering->major, TIERING_DEV_NAME);
	kfree(tiering);
}

module_init(hello_init);
module_exit(hello_exit);

MODULE_LICENSE("GPL");
